import processing.serial.*; 

PShader toon;
float time = 0.f;
Serial port;
int val;

void setup() {
  size(1920, 1080, P3D);
  //fullScreen(P3D);
  noStroke();
  frameRate(30);
  port = new Serial(this, Serial.list()[0], 9600); 
  toon = loadShader("frag.glsl");
  toon.set("resolution", float(width), float(height));
}

void draw() {
  background(0);
  time = frameCount / 500.0;
  if (0 < port.available()) {
    val = port.read();         
    //println(val);
    switch (val) {
      case 1: time += 0.05; break;
      case 2: time -= 0.05; break;
    }
    //time = val/100;
  } 
  toon.set("time", time);
  shader(toon);
  
  beginShape(QUADS);
    vertex(0, 0);
    vertex(width, 0);
    vertex(width, height);
    vertex(0, height);
  endShape();
  
  saveFrame("frame_####.png");
}

void mouseWheel(MouseEvent event) {
  time += event.getCount() / 100.f;
}

void keyReleased() {
  if (key == 's') {
    saveFrame("frame_####.png");
  }
}